<?php

require_once dirname(__FILE__) . '/library/OAuthRequestSigner.php';

define("DOCUMENTS_API_URL", "https://sandbox.viafirma.com/documents/api/v3");
define("DOCUMENTS_CONSUMER_KEY", "com.viafirma.documents.xxxxx");
define("DOCUMENTS_CONSUMER_SECRET", "xxxxx");

//echo system_alive();
$link=send_message ();

	echo "<html>";
	echo "<head>";
	echo "<style> html { overflow: hidden;} body { margin: 0;} </style>";
	echo "<title>Demo Consentimiento - viafirma</title>";
	echo "</head>";

	echo "<body>";
    echo '<iframe style="width:100%;height:100%;" src="'.$link.'" name="ventana_iframe" frameborder="0" allowfullscreen></iframe>';

   	echo "</body> ";
   	echo "</html>";


function system_alive ()
{
    error_reporting(E_ALL);

    header('Content-Type: text/plain; charset=utf-8');

    //echo "Documents OAuth 1.0a Client\n\n";
    //echo "See also: http://doc.viafirma.com/documents\n\n";

    $url=DOCUMENTS_API_URL."/system/alive";
    //echo "URL: ".$url."\n";

    //  Initiate curl
    $ch = curl_init();

    // Disable SSL verification
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

    // Will return the response, if false it print the response
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    // Set the url
    curl_setopt($ch, CURLOPT_URL,$url);

    // Execute
    $result=curl_exec($ch);
    echo prettyPrint($result);

    // Closing
    curl_close($ch);
}

function send_message ()
{
    error_reporting(E_ALL);

    //header('Content-Type: text/plain; charset=utf-8');

    $url=DOCUMENTS_API_URL."/messages/dispatch";
   // echo "URL: ".$url."\n";

    OAuthStore::instance('MySQL', array('conn'=>false));
    $req = new OAuthRequestSigner($url, 'POST');
    $fecha = new DateTime();
    $secrets = array(
                'consumer_key'      => DOCUMENTS_CONSUMER_KEY,
                'consumer_secret'   => DOCUMENTS_CONSUMER_SECRET,
                'token'             => '',
                'token_secret'      => '',
                'signature_methods' => array('HMAC-SHA1'),
                'nonce'             => '3jd834jd9',
                'timestamp'         => $fecha->getTimestamp(),
                );
    $req->sign(0, $secrets);

    // POST
    $string_json = file_get_contents("./demo-consentimiento.json");
    //echo $string_json;
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
    curl_setopt($ch, CURLOPT_POSTFIELDS, $string_json);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    // OAuth Header
    $headr = array();
    $headr[] = 'Content-Length: ' . strlen($string_json);
    $headr[] = 'Content-type: application/json';
    $headr[] = ''.$req->getAuthorizationHeader();
    curl_setopt($ch, CURLOPT_HTTPHEADER,$headr);

    $result = curl_exec($ch);
    $array = json_decode($result);
    $link=$array->notification->sharedLink->link;

    return $link;

    echo '<script>NombreiFrame.location.href = "'.$link.'";</script>'; 
    echo "Url para redirección o montar iframe: ";
    echo prettyPrint($result); 

    // Closing
    curl_close($ch);
}
function prettyPrint( $json )
{
    $result = '';
    $level = 0;
    $in_quotes = false;
    $in_escape = false;
    $ends_line_level = NULL;
    $json_length = strlen( $json );

    for( $i = 0; $i < $json_length; $i++ ) {
        $char = $json[$i];
        $new_line_level = NULL;
        $post = "";
        if( $ends_line_level !== NULL ) {
            $new_line_level = $ends_line_level;
            $ends_line_level = NULL;
        }
        if ( $in_escape ) {
            $in_escape = false;
        } else if( $char === '"' ) {
            $in_quotes = !$in_quotes;
        } else if( ! $in_quotes ) {
            switch( $char ) {
                case '}': case ']':
                    $level--;
                    $ends_line_level = NULL;
                    $new_line_level = $level;
                    break;

                case '{': case '[':
                    $level++;
                case ',':
                    $ends_line_level = $level;
                    break;

                case ':':
                    $post = " ";
                    break;

                case " ": case "\t": case "\n": case "\r":
                    $char = "";
                    $ends_line_level = $new_line_level;
                    $new_line_level = NULL;
                    break;
            }
        } else if ( $char === '\\' ) {
            $in_escape = true;
        }
        if( $new_line_level !== NULL ) {
            $result .= "\n".str_repeat( "\t", $new_line_level );
        }
        $result .= $char.$post;
    }

    return $result;
}
?> 